// v8sharp is a community project available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// View the project and the latest code at http://v8sharp.codeplex.com/

#pragma once

using namespace System;
using namespace System::Reflection;

namespace v8sharp {
	ref class V8Script;

	public ref class V8Engine abstract {
	internal:
		V8Engine() {}

	public:
		static V8Engine^ Create();

		virtual void Register(String^ name, Object^ instance) abstract;

		generic<typename T> 
		virtual void Register(String^ name, T instance) abstract;

		virtual void Register(String^ name, Object^ instance, Type^ type) abstract;

		virtual void RegisterFunction(String^ name, Delegate^ function) abstract;

		generic<typename T> 
		virtual void Register() abstract;

		virtual void Register(Type^ type) abstract;

		virtual void Register(Assembly^ assembly) abstract;

		virtual void Register(Assembly^ assembly, Predicate<Type^>^ typeFilter) abstract;

		virtual void Register(Assembly^ assembly, String^ nameSpace) abstract;

		virtual Object^ Execute(String^ script) abstract;

		virtual Object^ Execute(V8Script^ script) abstract;

		virtual V8Script^ Compile(String^ script) abstract;
	};
}