// v8sharp is a community project available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// View the project and the latest code at http://v8sharp.codeplex.com/

#pragma once

#include "v8script.h"
#include <v8.h>

class V8ScriptWrapper;

namespace v8sharp {
	ref class V8ScriptImpl sealed : V8Script {
	public:
		~V8ScriptImpl() { Destroy(); }

		property String^ ScriptText {
			virtual String^ get() override;
		}

		property bool HasExceptions {
			virtual bool get() override;
		}

		property IList<Exception^>^ Exceptions {
			virtual IList<Exception^>^ get() override;
		}

	internal: 
		static V8Script^ Compile(v8::Persistent<v8::Context> context, String^ script);

		Object^ Execute(v8::Persistent<v8::Context> context);

	private:
		String^ scriptText;
		IList<Exception^>^ exceptions;

		V8ScriptWrapper* compiledScript;

		V8ScriptImpl() {}

		void Destroy();
	};
}

class V8ScriptWrapper {
private:
	v8::Persistent<v8::Script> script;

public:
	V8ScriptWrapper(v8::Persistent<v8::Script> script);

	~V8ScriptWrapper();

	v8::Persistent<v8::Script> GetScript();
};