// v8sharp is a community project available under the Microsoft Public License (Ms-PL)
// Code is provided as is and with no warrenty  Use at your own risk
// View the project and the latest code at http://v8sharp.codeplex.com/

#pragma once

#include <v8.h>

using namespace System;

namespace v8sharp {
	ref class V8ValueWrapper sealed {
	public:
		static Object^ Wrap(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> Unwrap(Object^ value);

	private:
		static String^ WrapString(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapString(String^ value);

		static bool WrapBoolean(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapBoolean(bool value);

		static int WrapInt32(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapInt32(int value);

		static double WrapDouble(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapDouble(double value);

		static cli::array<Object^>^ WrapArray(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapArray(Array^ value);

		static DateTime WrapDate(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapDate(DateTime value);

		static Delegate^ WrapFunction(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapFunction(Delegate^ value);

		static Object^ WrapObject(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapObject(Object^ value);

		static Object^ WrapExternal(v8::Handle<v8::Value> value);

		static v8::Handle<v8::Value> UnwrapExternal(Object^ value);
	};
}